#include  "xc.h"      // XC general include file
#include  "stdint.h"    // Integer definition
#include  "stdbool.h"    // Boolean (true/false) definition

 void _delayX(unsigned long cycles);
 
// CONFIG1
#pragma config FOSC = XT    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable (Brown-out Reset disabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)
// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = ON      // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)



/*
   /Um ein Pin eines Ports als Ausgang zu nutzen, muss es erst als Ausgang initialisiert werden,
wozu das zugehrige Bit im TRISx - Register dieses Ports auf '0' gesetzt werden muss
   TRISA = 0           		 // alle  Ports A als Ausgnge definieren
   TRISAbits.TRISA0 = 1  		//nur das A0 als Eingang

Zum Schreiben auf einen Portpin kann man die beide Register  LAT oder PORT verwenden:

LATB = 0x0F ;          	// RB0..RB3: High-Pegel, RB4..RB7: Low-Pegel
LATBbits.LATB0 = 0;       //RB0 auf 0 setzen

PORTB = 0x0F ;          		// RB0..RB3: High-Pegel, RB4..RB7: Low-Pegel
PORTBbits.RB0 = 0;      		 //RB0 auf 0 setzen

Nur beim Lesen kann es zu Problemen kommen.  Mit den PORT Register werden Pins Zustnde
Ausgelesen und die knnen durch externe Spannungen nicht dem LAT Register entsprechen.
Und es kann passieren:

	PORTABits.RB0 != LATAbits.LATB0;


*/
unsigned char WochenTag,Stunde,Minute,Sekunde;
unsigned char SleepZaehler,InterruptDa;
void interrupt intr(void)
{
    if (PIR1bits.TMR1IF )
    {    
      PIR1bits.TMR1IF = 0;
      TMR1H = 0b10000000;
      LATAbits.LATA0 ^=1; //!=  LATAbits.LATA0;  
      RA1 = 1;

if(Sekunde>=59)
      {
        Sekunde=0;
        if(Minute>=59)
         {
           Minute=0;
            if(Stunde>=23)
             {
               Stunde=0;
                if(WochenTag>=6)
                 WochenTag=0;
                else
                ++WochenTag;
             }
            else
           ++Stunde;
         }
        else
         ++Minute;
      }
     else
     Sekunde+=1;

      InterruptDa=1;
     
    } 
}




void InitProg(void);
void main(void);

/********************************************************/
//main();
/********************************************************/
/*==============================================================================
  Main program loop. The main() function is called first by the compiler.
==============================================================================*/

void main(void)

{
SleepZaehler =0;
InterruptDa=0;
/*
Der Timer1 soll einen Interrupt auslsen und den PIC aus seinem Sleep
holen.
INTCON,PEIE = 1
T1CON = 0x0F
PIE,TMR1IE = 1
*/
/*
A low-power 32.768 kHz crystal oscillator is built-in
between pins OSC1 (input) and OSC2 (amplifier output).
The oscillator is enabled by setting the T1OSCEN
control bit of the T1CON register. The oscillator will
continue to run during Sleep.
The Timer1 oscillator is shared with the system LP
oscillator. Thus, Timer1 can use this mode only when
the primary system clock is derived from the internal
oscillator or when in LP oscillator mode. The user must
provide a software time delay to ensure proper oscillator
start-up.
TRISA5 and TRISA4 bits are set when the Timer1
oscillator is enabled. RA5 and RA4 bits read as ?0? and
TRISA5 and TRISA4 bits read as ?1?.

Oder ist es so zu verstehen, dass ich dort einen Quarz anschlieen muss?
*/

  InitProg();
 
  RA2= 0;
  
        while(1)
        {
    
   
      
       if (InterruptDa)
       {
         InterruptDa =0;
                  
         SLEEP(); 
         NOP();
         NOP();
         NOP();
          
         
        }
        }
}


//PIE1: PERIPHERAL INTERRUPT ENABLE REGISTER 1
#define TMR1GIE  (0b0<<7)    //Timer1 Gate Interrupt Enable 
#define ADIE     (0b0<<6)    //A/D Converter (ADC) Interrupt Enable
#define RCIE     (0b0<<5)    //USART Receive Interrupt Enable
#define TXIE     (0b0<<4)    //USART Transmit Interrupt Enable
#define SSP1IE   (0b0<<3)    //Synchronous Serial Port (MSSP) Interrupt Enable
#define CCP1IE   (0b0<<2)    //CCP1 Interrupt Enable
#define TMR2IE   (0b0<<1)    //TMR2 to PR2 Match Interrupt Enable
#define TMR1IE   (0b1<<0)    //Timer1 Overflow Interrupt Enable
#define PIE1_    TMR1GIE|ADIE|RCIE|TXIE|SSP1IE|CCP1IE|TMR2IE|TMR1IE

//INTCON: INTERRUPT CONTROL REGISTER
#define GIE    (0b1<<7)    //Global Interrupt Enable 
#define PEIE   (0b1<<6)    //Peripheral Interrupt Enable 
#define TMR0IE (0b0<<5)    //Timer0 Overflow Interrupt Enable 
#define INTE   (0b0<<4)    //INT External Interrupt Enable 
#define IOCIE  (0b0<<3)    //Interrupt-on-Change Enable 
#define TMR0IF (0b0<<2)    //Timer0 Overflow Interrupt Flag 
#define INTF   (0b0<<1)    //INT External Interrupt Flag 
#define IOCIF  (0b0)       //Interrupt-on-Change Interrupt Flag
#define INTCON_  GIE|PEIE|TMR0IE|INTE|IOCIE|TMR0IF|INTF|IOCIF

//CPSCON0: CAPACITIVE SENSING CONTROL REGISTER 0
#define CPSON  (0b0<<7)    //CPS Module Enable bit
#define CPSRM  (0b0<<6)    //Capacitive Sensing Reference Mode bit
#define CPSRNG (0b00<<3)   //Capacitive Sensing Current Range bit
#define CPSOUT (0b0<<1)    //Capacitive Sensing Oscillator Status bit
#define T0XCS  (0b0)       //Timer0 External Clock Source Select bit :Timer0 clock source is the T0CKI pin
#define CPSCON0_ CPSON|CPSRM|CPSRNG|CPSOUT|T0XCS

//OPTION_REG: OPTION REGISTER
#define WPUEN    (0b1<<7)      //Weak Pull-up Disable
#define INTEDG   (0b1<<6)      //Interrupt Edge Select bit
#define TMR0CS   (0b1<<5)      //Timer0 Clock Source Select bit 1 = Transition on RA2/T0CKI pin
#define TMR0SE   (0b1<<4)      //Timer0 Source Edge Select bit
#define PSA      (0b0<<3)      // Prescaler Assignment bit
#define Prescaler (0b000<<2)   //Rate Select bits
#define OPTION_REG_ WPUEN|INTEDG|TMR0CS|TMR0SE|PSA|Prescaler


    /*TMR1ON bit of the T1CON register
    TMR1IE bit of the PIE1 register
    PEIE bit of the INTCON register
    GIE bit of the INTCON register*/

//T1CON: TIMER1 CONTROL REGISTER
#define TMR1CS  (0b01<<7)//(0b10<<7)  //Timer1 clock source is pin or oscillator
#define T1CKPS  (0b00<<5)  //Timer1 Input Clock Prescale Select  = 1
#define T1OSCEN (0b1<<3)   //LP Oscillator Enable Control bit
#define T1SYNC   (0b1<<2)  //Timer1 External Clock Input Synchronization Control bit. 0- nicht synchronisieren
#define TMR1ON    (0b1)    // Timer1 On bit
#define T1CON_  TMR1CS|T1CKPS|T1OSCEN|T1SYNC|T1SYNC|TMR1ON


//OSCCON: OSCILLATOR CONTROL REGISTER
#define SPLLEN (0b0<<7) //Software PLL Enable bit 
#define IRCF (0b1111<<6)   //Internal Oscillator Frequency Select 4MHZ
#define SCS   (0b00)  //System Clock Select bits: Internal oscillator block
#define OSCCON_ SPLLEN|IRCF|SCS

//ANSELA: PORTA ANALOG SELECT REGISTER
#define ANSA4    (0b0<<4)      //Analog Select between Analog or Digital Function on pins RA4, 1: Analog, 0:Digital
#define ANSA2_0  (0b000<<2)    //Analog Select between Analog or Digital Function on pins RA2 bis RA02
#define ANSELA_   ANSA4|ANSA2_0

//TRISA: PORTA TRI-STATE REGISTER
#define TRISA_PortA5_bis_PortA4 (0b11<<5)  // : 1:Input 0:Output
#define TRISA_PortA3  (0b1<<3)                     //always 1 as RA3 is an input only
#define TRISA_PortA2_bisPortA0 (0b000)  // : 1:Input 0:Output
#define TRISA_   TRISA_PortA5_bis_PortA4|TRISA_PortA3|TRISA_PortA2_bisPortA0

void InitProg(void)
{
// Initialize user ports and peripherals.
        T1CON = T1CON_;
        OSCCON = OSCCON_; 
        ANSELA = ANSELA_;
        TRISA = TRISA_;
        PIE1 = PIE1_;  
        CPSCON0 = CPSCON0_;
        OPTION_REG = OPTION_REG_;
        INTCON = INTCON_;
        

        PORTA = 0;        // Turn all PORTA outputs off
}

 void _delayX(unsigned long Var)
 {
   while(Var) 
       --Var;
 }
       


